(function() {
  var local, storage, sys, ua;
  sys = require('sys');
  storage = require('./storage');
  ua = require('useragent');
  exports.requestTracker = function(req, res, next) {
    var host, startTime, totalTime, ua_data;
    host = req.header('host');
    ua_data = ua.parser(req.header('user-agent'));
    startTime = new Date().valueOf();
    if (!local(host)) {
      console.log("I am invoked " + req.url);
      storage.start(host, req.url, req.header('x-forwarded-for') || req.connection.remoteAddress, {
        referrer: req.header('Referer') || "",
        user_agent: req.header('user-agent'),
        browser: ua_data.pretty(),
        os: ua_data.prettyOs(),
        type: req.method
      }, function(replies) {
        return sys.inspect(replies);
      });
    }
    next();
    if (!local(host)) {
      totalTime = new Date().valueOf() - startTime;
      console.log("Response Headers " + res.statusCode);
      storage.finish(req.header('host'), req.url, totalTime, res.code);
      return console.log("Invocation done.... in " + totalTime);
    }
  };
  local = function(host) {
    return false;
  };
}).call(this);
